# Prupose: Generate outputs
# Input:	argus_recoded_wtd
# Outout:   R_Datasets\\outputsummary.wtd.nodelete.RData
#			R_Datasets\\outputsummary.unwtd.nodelete.RData
#			R_Datasets\\outputsummary.wtd.delete.RData
# 			R_Datasets\\outputsummary.unwtd.delete.RData
# 			\\Output\\outputsummary_wtd.csv
# 			\\Output\\outputsummary_unwtd.csv

# Author: Yali Chen
# Aug, 2016

#rm(list = ls(all = TRUE))
#options(run.main=TRUE)

################################################################################
########################## Auxiliary Functions #################################
################################################################################
{
   
  # Function for aggregation
  aggreg <- function (project,predesc,preper,testdesc,reporttype,datain,demo,
                      segment,merch,expcount,desc,wherestate,weightvar,
                      testper,Totalvar) {
    
    # For Dynamic renaming
    segment_transyes_preper  <- parse(text=paste(segment,"transyes",preper,sep="_"))
    segment_transyes_testper <- parse(text=paste(segment,"transyes",testper,sep="_"))
    
    total_segment_transyes_preper  <- parse(text=paste(segment,"transyes",preper,"total",sep="_"))
    total_segment_transyes_testper <- parse(text=paste(segment,"transyes",testper,"total",sep="_"))
    
    segment_trans_preper     <- parse(text=paste(segment,"trans",preper,sep="_"))
    segment_trans_testper    <- parse(text=paste(segment,"trans",testper,sep="_"))
    
    segment_spend_preper     <- parse(text=paste(segment,"spend",preper,sep="_"))
    segment_spend_testper    <- parse(text=paste(segment,"spend",testper,sep="_"))
    
    Totalvar_spend_preper    <- parse(text=paste(Totalvar,"spend",preper,sep="_"))
    Totalvar_spend_testper   <- parse(text=paste(Totalvar,"spend",testper,sep="_"))
    
    expcount   <- parse(text=expcount)
    weightvar  <- parse(text=weightvar)
    wherestate <- parse(text=wherestate)
    
    # dataout                            <- data.table(Exposure = project)
    # dataout$PrePeriod                  <- predesc
    # dataout$TestPeriod                 <- testdesc
    # dataout$Type                       <- reporttype
    # dataout$Demo                       <- demo
    # dataout$Freq                       <- desc
    # dataout$Merchant                   <- merch
    # dataout$Freqmin                    <- datain[eval(wherestate),min(eval(expcount))]
    # dataout$Freqmax                    <- datain[eval(wherestate),max(eval(expcount))]
    # dataout$MatchedSample              <- datain[eval(wherestate),sum(sample)] #Sample
    # #dataout$MatchedSample              <- datain[eval(wherestate),
    #                                       sum(sample*eval(weightvar))]
    # dataout$ESS                        <- datain[eval(wherestate),
    #                                       ((sum(eval(weightvar)))^2)/
    #                                       (sum(eval(weightvar)^2))]
    # 
    # # Buyer counts
    # dataout$BuyersPre                 <- datain[eval(wherestate),
    #                                       sum(eval(segment_transyes_preper)*
    #                                       eval(weightvar))] #SpendersPre
    # dataout$BuyersTest                <- datain[eval(wherestate),
    #                                       sum(eval(segment_transyes_testper)*
    #                                       eval(weightvar))] #SpendersTest
    # dataout$BuyersChange              <- dataout[,100*((BuyersTest-BuyersPre)/
    #                                                BuyersPre)] #SpendersChange
    # 
    # # Buyer Penetration
    # dataout$PenetrationPre             <- dataout[,100*(BuyersPre/MatchedSample)]
    # dataout$PenetrationTest            <- dataout[,100*(BuyersTest/MatchedSample)]
    # dataout$PenetrationChange          <- dataout[,100*((PenetrationTest-PenetrationPre)/
    #                                                PenetrationPre)]
    # 
    # # Avg Transactions per buyer
    # dataout$AvgTransactionsPre         <- datain[eval(wherestate),
    #                                       sum(eval(segment_trans_preper)*eval(weightvar))]
    # dataout$AvgTransactionsPre         <- dataout[,AvgTransactionsPre/BuyersPre]
    # dataout$AvgTransactionsTest        <- datain[eval(wherestate),
    #                                       sum(eval(segment_trans_testper)*eval(weightvar))]
    # dataout$AvgTransactionsTest        <- dataout[,AvgTransactionsTest/BuyersTest]
    # dataout$AvgTransactionsChange      <- dataout[,100*((AvgTransactionsTest-
    #                                                AvgTransactionsPre)/AvgTransactionsPre)]
    # 
    # # Spending per Transactions
    # dataout$SpendPerTransactionsPre    <- datain[eval(wherestate),
    #                                       sum(eval(segment_spend_preper)*
    #                                       eval(weightvar))/sum(eval(segment_trans_preper)*
    #                                       eval(weightvar))]
    # dataout$SpendPerTransactionsTest   <- datain[eval(wherestate),
    #                                       sum(eval(segment_spend_testper)*
    #                                       eval(weightvar))/sum(eval(segment_trans_testper)*
    #                                       eval(weightvar))]
    # dataout$SpendPerTransactionsChange <- dataout[,100*((SpendPerTransactionsTest-
    #                                                SpendPerTransactionsPre)/
    #                                                SpendPerTransactionsPre)]
    # 
    # # Avg Spending per buyer
    # dataout$AvgSpendPre               <- datain[eval(wherestate),
    #                                      sum(eval(segment_spend_preper)*eval(weightvar))]
    # dataout$AvgSpendPre               <- dataout[,AvgSpendPre/BuyersPre]
    # dataout$AvgSpendTest              <- datain[eval(wherestate),
    #                                      sum(eval(segment_spend_testper)*eval(weightvar))]
    # dataout$AvgSpendTest              <- dataout[,AvgSpendTest/BuyersTest]
    # dataout$AvgSpendChange            <- dataout[,100*((AvgSpendTest-AvgSpendPre)/
    #                                               AvgSpendPre)]
    # 
    # # Share of Category
    # dataout$ShareCategoryPre          <- datain[eval(wherestate),
    #                                      100*(sum(eval(segment_spend_preper)*
    #                                      eval(weightvar))/
    #                                      sum(eval(Totalvar_spend_preper)*eval(weightvar)))]
    # dataout$ShareCategoryTest         <- datain[eval(wherestate),
    #                                      100*(sum(eval(segment_spend_testper)*
    #                                      eval(weightvar))/
    #                                      sum(eval(Totalvar_spend_testper)*eval(weightvar)))]
    # dataout$ShareCategoryChange       <- dataout[,100*((ShareCategoryTest-
    #                                               ShareCategoryPre)/ShareCategoryPre)]
    # # Buyer Total counts
    # dataout$BuyersTotalPre            <- datain[eval(wherestate),
    #                                      sum(eval(total_segment_transyes_preper)*eval(weightvar))] 
    # dataout$BuyersTotalTest           <- datain[eval(wherestate),
    #                                      sum(eval(total_segment_transyes_testper)*eval(weightvar))]
    # 
    # # Total Transaction
    # dataout$TotalTransactionsPre      <- datain[eval(wherestate),
    #                                      sum(eval(segment_trans_preper)*eval(weightvar))]
    # dataout$TotalTransactionsTest     <- datain[eval(wherestate),
    #                                      sum(eval(segment_trans_testper)*eval(weightvar))]
    # dataout$TotalTransactionsChange   <- dataout[,100*((TotalTransactionsTest-
    #                                               TotalTransactionsPre)/TotalTransactionsPre)]
    # 
    # # Total Spend
    # dataout$TotalSpendPre             <- datain[eval(wherestate),
    #                                      sum(eval(segment_spend_preper)*eval(weightvar))]
    # dataout$TotalSpendTest            <- datain[eval(wherestate),
    #                                      sum(eval(segment_spend_testper)*eval(weightvar))]
    # dataout$TotalSpendChange          <- dataout[,100*((TotalSpendTest-TotalSpendPre)/
    #                                               TotalSpendPre)]
    # 
    # # Spend per person
    # dataout$SpendPerPersonPre         <- datain[eval(wherestate),
    #                                      sum(eval(segment_spend_preper)*
    #                                      eval(weightvar))]
    # dataout$SpendPerPersonPre         <- dataout[,SpendPerPersonPre/MatchedSample]
    # dataout$SpendPerPersonTest        <- datain[eval(wherestate),
    #                                      sum(eval(segment_spend_testper)*
    #                                      eval(weightvar))]
    # dataout$SpendPerPersonTest        <- dataout[,SpendPerPersonTest/MatchedSample]
    # dataout$SpendPerPersonChange      <- dataout[,100*((SpendPerPersonTest-
    #                                               SpendPerPersonPre)/SpendPerPersonPre)]
    
    dataout <- datain[eval(wherestate), {
       Exposure                  = project
       PrePeriod                 = predesc
       TestPeriod                = testdesc
       Type                      = reporttype
       Demo                      = demo
       Freq                      = desc
       Merchant                  = merch
       Freqmin                   = min(eval(expcount),na.rm=T)
       Freqmax                   = max(eval(expcount),na.rm=T)
       Sample                    = sum(sample,na.rm=T) #Sample
       MatchedSample             = sum(sample*eval(weightvar),na.rm=T)
       ESS                       = ((sum(eval(weightvar),na.rm=T))^2)/
                                   (sum(eval(weightvar)^2,na.rm=T))

       # Buyer counts
       BuyersPre                 = sum(eval(segment_transyes_preper)*eval(weightvar),
                                       na.rm=T) #SpendersPre
       BuyersTest                = sum(eval(segment_transyes_testper)*eval(weightvar),
                                       na.rm=T) #SpendersTest
       BuyersChange              = 100*((BuyersTest - BuyersPre) / BuyersPre) #SpendersChange
       
       # Buyer Penetration
       PenetrationPre            = 100*(BuyersPre / MatchedSample)
       PenetrationTest           = 100*(BuyersTest / MatchedSample)
       PenetrationChange         = 100*((PenetrationTest - PenetrationPre) / PenetrationPre)
      
       # Avg Transactions per buyer
       AvgTransactionsPre        = sum(eval(segment_trans_preper)*eval(weightvar),
                                       na.rm=T) / BuyersPre
       AvgTransactionsTest       = sum(eval(segment_trans_testper)*eval(weightvar),
                                       na.rm=T) / BuyersTest
       AvgTransactionsChange     = 100*((AvgTransactionsTest-AvgTransactionsPre)/
                                         AvgTransactionsPre)
     
       # Spending per Transactions
       SpendPerTransactionsPre   = sum(eval(segment_spend_preper)*eval(weightvar),na.rm=T)/
                                   sum(eval(segment_trans_preper)*eval(weightvar),na.rm=T)
       SpendPerTransactionsTest  = sum(eval(segment_spend_testper)*eval(weightvar),na.rm=T)/
                                   sum(eval(segment_trans_testper)*eval(weightvar),na.rm=T)
       SpendPerTransactionsChange= 100*((SpendPerTransactionsTest-SpendPerTransactionsPre)/
                                          SpendPerTransactionsPre)
    
       # Avg Spending per buyer
       AvgSpendPre               = sum(eval(segment_spend_preper)*eval(weightvar),
                                       na.rm=T)/BuyersPre
       AvgSpendTest              = sum(eval(segment_spend_testper)*eval(weightvar),
                                       na.rm=T)/BuyersTest
       AvgSpendChange            = 100*((AvgSpendTest-AvgSpendPre)/AvgSpendPre)
    
       # Share of Category
       ShareCategoryPre          = 100*(sum(eval(segment_spend_preper)*eval(weightvar),na.rm=T)/
                                        sum(eval(Totalvar_spend_preper)*eval(weightvar),na.rm=T))
       ShareCategoryTest         = 100*(sum(eval(segment_spend_testper)*eval(weightvar),na.rm=T)/
                                        sum(eval(Totalvar_spend_testper)*eval(weightvar),na.rm=T))
       ShareCategoryChange       = 100*((ShareCategoryTest-ShareCategoryPre)/ShareCategoryPre)
       
       # Buyer Total counts
       BuyersTotalPre             = sum(eval(total_segment_transyes_preper)*eval(weightvar),na.rm=T)
       BuyersTotalTest            = sum(eval(total_segment_transyes_testper)*eval(weightvar),na.rm=T)
       
       # Total Transaction
       # TotalTransactionsPre       = sum(eval(segment_trans_preper)*eval(weightvar))
       # TotalTransactionsTest      = sum(eval(segment_trans_testper)*eval(weightvar))
       # TotalTransactionsChange    = 100*((TotalTransactionsTest - TotalTransactionsPre) / TotalTransactionsPre)
      
       # Total Spend
       # TotalSpendPre              = sum(eval(segment_spend_preper)*eval(weightvar))
       # TotalSpendTest             = sum(eval(segment_spend_testper)*eval(weightvar))
       # TotalSpendChange           = 100*((TotalSpendTest - TotalSpendPre) / TotalSpendPre)
       
       # Spend per person
       # SpendPerPersonPre          = sum(eval(segment_spend_preper)*eval(weightvar)) / MatchedSample
       # SpendPerPersonTest         = sum(eval(segment_spend_testper)*eval(weightvar)) / MatchedSample
       # SpendPerPersonChange       = 100*((SpendPerPersonTest - SpendPerPersonPre) / SpendPerPersonPre)

       list(
         Exposure                   = Exposure
        ,PrePeriod                  = PrePeriod
        ,TestPeriod                 = TestPeriod
        ,Type                       = Type
        ,Demo                       = Demo
        ,Freq                       = Freq
        ,Merchant                   = Merchant
        ,Freqmin                    = Freqmin
        ,Freqmax                    = Freqmax
        #,Sample                    = Sample
        ,MatchedSample              = Sample
        ,ESS                        = ESS
        ,BuyersPre                  = BuyersPre
        ,BuyersTest                 = BuyersTest
        ,BuyersChange               = BuyersChange
        ,PenetrationPre             = PenetrationPre
        ,PenetrationTest            = PenetrationTest
        ,PenetrationChange          = PenetrationChange
        ,AvgTransactionsPre         = AvgTransactionsPre
        ,AvgTransactionsTest        = AvgTransactionsTest
        ,AvgTransactionsChange      = AvgTransactionsChange
        ,SpendPerTransactionsPre    = SpendPerTransactionsPre
        ,SpendPerTransactionsTest   = SpendPerTransactionsTest
        ,SpendPerTransactionsChange = SpendPerTransactionsChange
        ,AvgSpendPre                = AvgSpendPre
        ,AvgSpendTest               = AvgSpendTest
        ,AvgSpendChange             = AvgSpendChange
        ,ShareCategoryPre           = ShareCategoryPre
        ,ShareCategoryTest          = ShareCategoryTest
        ,ShareCategoryChange        = ShareCategoryChange
        ,BuyersTotalPre             = BuyersTotalPre
        ,BuyersTotalTest            = BuyersTotalTest
        # ,TotalTransactionsPre       = TotalTransactionsPre
        # ,TotalTransactionsTest      = TotalTransactionsTest
        # ,TotalTransactionsChange    = TotalTransactionsChange
        # ,TotalSpendPre              = TotalSpendPre
        # ,TotalSpendTest             = TotalSpendTest
        # ,TotalSpendChange           = TotalSpendChange
        # ,SpendPerPersonPre          = SpendPerPersonPre
        # ,SpendPerPersonTest         = SpendPerPersonTest
        # ,SpendPerPersonChange       = SpendPerPersonChange
        )}]
    
    if (nrow(dataout) == 0) {
      dataout <- data.table("Exposure"                    = project
                            ,"PrePeriod"                  = predesc
                            ,"TestPeriod"                 = testdesc
                            ,"Type"                       = reporttype
                            ,"Demo"                       = demo
                            ,"Freq"                       = desc
                            ,"Merchant"                   = merch
                            ,"Freqmin"                    = NA
                            ,"Freqmax"                    = NA
                            ,"MatchedSample"              = NA
                            ,"ESS"                        = NA
                            ,"BuyersPre"                  = NA
                            ,"BuyersTest"                 = NA
                            ,"BuyersChange"               = NA
                            ,"PenetrationPre"             = NA
                            ,"PenetrationTest"            = NA
                            ,"PenetrationChange"          = NA
                            ,"AvgTransactionsPre"         = NA
                            ,"AvgTransactionsTest"        = NA
                            ,"AvgTransactionsChange"      = NA
                            ,"SpendPerTransactionsPre"    = NA
                            ,"SpendPerTransactionsTest"   = NA
                            ,"SpendPerTransactionsChange" = NA
                            ,"AvgSpendPre"                = NA
                            ,"AvgSpendTest"               = NA
                            ,"AvgSpendChange"             = NA
                            ,"ShareCategoryPre"           = NA
                            ,"ShareCategoryTest"          = NA
                            ,"ShareCategoryChange"        = NA
                            ,"BuyersTotalPre"             = NA
                            ,"BuyersTotalTest"            = NA
                            #,"TotalTransactionsPre"      = NA
                            #,"TotalTransactionsTest"     = NA
                            #,"TotalTransactionsChange"   = NA
                            #,"TotalSpendPre"             = NA
                            #,"TotalSpendTest"            = NA
                            #,"TotalSpendChange"          = NA
                            #,"SpendPerPersonPre"         = NA
                            #,"SpendPerPersonTest"        = NA
                            #,"SpendPerPersonChange"      = NA
                            )
    }
                       
    return(dataout)
    
  }
  
  # Function for aggregation
  # project = params$exposure[expnum]
  # publisher = publishername
  # creative = creativename
  # tactic = tacticname
  # mediatype = mediatypename
  # market = marketname
  # age = agename
  # gender = gendername
  # predesc = params$period.agg.def.fr$pre
  # predescNMC = params$prefr
  # pretypedesc = params$prefrtype
  # campaigndesc = params$testfr
  # postdesc = params$postfr
  # posttypedesc = params$postfrtype
  # testdesc = params$tspsfr
  # preper = prtime
  # reporttype = eval(parse(text=paste0("typn",types)))
  # datain = inputdata
  # demo = demoname
  # segment = segm
  # merch = segd
  # merchkey = segkey
  # expcount = tolower(params$explist[expnum])
  # desc = "Total"
  # wherestate = paste("(datain$sample == 1)",
  #                    eval(parse(text=paste0("typst",types))),
  #                    paste0('(datain$',demovar," == 1)"),sep = " & ")
  # weightvar = weight
  # testper = antime        
  # Totalvar = tolower(params$totalvar)
  aggreg_NMC <- function (project,publisher,creative,tactic,mediatype,market,
                          age,gender,predesc,predescNMC,
                          pretypedesc,campaigndesc,postdesc,posttypedesc,
                          preper,testdesc,reporttype,datain,
                          demo,segment,merch,
                          merchkey,
                          expcount,desc,wherestate,weightvar,
                          testper,Totalvar) {

    # For Dynamic renaming
    segment_transyes_preper  <- parse(text=paste(segment,"transyes",preper,sep="_"))
    segment_transyes_testper <- parse(text=paste(segment,"transyes",testper,sep="_"))
    total_segment_transyes_preper  <- parse(text=paste(segment,"transyes",preper,"total",sep="_"))
    total_segment_transyes_testper <- parse(text=paste(segment,"transyes",testper,"total",sep="_"))
    segment_trans_preper     <- parse(text=paste(segment,"trans",preper,sep="_"))
    segment_trans_testper    <- parse(text=paste(segment,"trans",testper,sep="_"))
    segment_spend_preper     <- parse(text=paste(segment,"spend",preper,sep="_"))
    segment_spend_testper    <- parse(text=paste(segment,"spend",testper,sep="_"))
    Totalvar_spend_preper    <- parse(text=paste(Totalvar,"spend",preper,sep="_"))
    Totalvar_spend_testper   <- parse(text=paste(Totalvar,"spend",testper,sep="_"))
    expcount   <- parse(text=expcount)
    weightvar  <- parse(text=weightvar)
    wherestate <- parse(text=wherestate)
   
    dataout <- datain[eval(wherestate), {
      Exposure                  = project
      Publisher                 = publisher
      Creative                  = creative
      Tactic                    = tactic
      MediaType                 = mediatype
      Age                       = age
      Gender                    = gender
      Market                    = market
      PrePeriod                 = predesc
      PrePeriodNMC              = predescNMC
      
      PrePeriodType             = pretypedesc
      CampaignPeriod            = campaigndesc
      PostPeriod                = postdesc
      PostPeriodType            = posttypedesc
      
      TestPeriod                = testdesc
      Type                      = reporttype
      Demo                      = demo
      Merchant                  = merch
      
      MerchantKey               = merchkey
      
      Freq                      = desc
      Freqmin                   = min(eval(expcount),na.rm=T)
      Freqmax                   = max(eval(expcount),na.rm=T)
      Sample                    = sum(sample,na.rm=T)
      MatchedSample             = sum(sample*eval(weightvar),na.rm=T)
      ESS                       = ((sum(eval(weightvar),na.rm=T))^2)/
                                  (sum(eval(weightvar)^2,na.rm=T))
    
      # Buyer counts
      BuyersPre                 = sum(eval(segment_transyes_preper)*eval(weightvar),
                                      na.rm=T) #SpendersPre
      BuyersTest                = sum(eval(segment_transyes_testper)*eval(weightvar),
                                      na.rm=T) #SpendersTest
      BuyersChange              = 100*((BuyersTest - BuyersPre) / BuyersPre) #SpendersChange
      BuyersLift                = 0 #SpendersLift
      
      # Buyer Penetration
      PenetrationPre            = 100*(BuyersPre / MatchedSample) 
      PenetrationTest           = 100*(BuyersTest / MatchedSample)
      PenetrationChange         = 100*((PenetrationTest - PenetrationPre)/PenetrationPre)
      PenetrationLift           = 0
      
      # Avg Transactions per buyer
      AvgTransactionsPre        = sum(eval(segment_trans_preper)*eval(weightvar),
                                      na.rm=T) / BuyersPre
      AvgTransactionsTest       = sum(eval(segment_trans_testper)*eval(weightvar),
                                      na.rm=T) / BuyersTest
      AvgTransactionsChange     = 100*((AvgTransactionsTest - AvgTransactionsPre)/
                                         AvgTransactionsPre)
      AvgTransactionsLift       = 0
      
      # Spending per Transactions
      SpendPerTransactionsPre   = sum(eval(segment_spend_preper) *eval(weightvar),na.rm=T)/
                                  sum(eval(segment_trans_preper)*eval(weightvar),na.rm=T) 
      SpendPerTransactionsTest  = sum(eval(segment_spend_testper) *eval(weightvar),na.rm=T)/
                                  sum(eval(segment_trans_testper)*eval(weightvar),na.rm=T)
      SpendPerTransactionsChange= 100*((SpendPerTransactionsTest-SpendPerTransactionsPre)/
                                       SpendPerTransactionsPre)
      SpendPerTransactionsLift  = 0
      
      # Avg Spending per buyer
      AvgSpendPre               = sum(eval(segment_spend_preper)*eval(weightvar),
                                      na.rm=T)/BuyersPre 
      AvgSpendTest              = sum(eval(segment_spend_testper)*eval(weightvar),
                                      na.rm=T)/BuyersTest 
      AvgSpendChange            = 100*((AvgSpendTest-AvgSpendPre)/AvgSpendPre)
      AvgSpendLift              = 0
      
      # Share of Category
      ShareCategoryPre          = 100*(sum(eval(segment_spend_preper)*eval(weightvar),na.rm=T)/
                                       sum(eval(Totalvar_spend_preper)*eval(weightvar),na.rm=T))
      ShareCategoryTest         = 100*(sum(eval(segment_spend_testper)*eval(weightvar),na.rm=T)/
                                       sum(eval(Totalvar_spend_testper)*eval(weightvar),na.rm=T))
      ShareCategoryChange       = 100*((ShareCategoryTest-ShareCategoryPre)/ShareCategoryPre)      
      ShareCategoryLift         = 0
   
      # Buyer Total counts
      BuyersTotalPre            = sum(eval(total_segment_transyes_preper)*eval(weightvar),na.rm=T)
      BuyersTotalTest           = sum(eval(total_segment_transyes_testper)*eval(weightvar),na.rm=T)
      BuyersTotalChange         = 100*((BuyersTotalTest-BuyersTotalPre)/BuyersTotalPre)
      BuyersTotalLift           = 0

      # Total Transaction
      TotalTransactionsPre       = sum(eval(segment_trans_preper)*eval(weightvar),na.rm=T)
      TotalTransactionsTest      = sum(eval(segment_trans_testper)*eval(weightvar),na.rm=T)
      TotalTransactionsChange    = 100*((TotalTransactionsTest-TotalTransactionsPre)/
                                          TotalTransactionsPre)
      TotalTransactionsLift      = 0
      
      # Total Spend
      TotalSpendPre              = sum(eval(segment_spend_preper)*eval(weightvar),na.rm=T)
      TotalSpendTest             = sum(eval(segment_spend_testper)*eval(weightvar),na.rm=T)
      TotalSpendChange           = 100*((TotalSpendTest-TotalSpendPre)/TotalSpendPre)
      TotalSpendLift             = 0
      
      # Spend per person
      SpendPerPersonPre          = sum(eval(segment_spend_preper)*eval(weightvar),
                                       na.rm=T)/MatchedSample
      SpendPerPersonTest         = sum(eval(segment_spend_testper)*eval(weightvar),
                                       na.rm=T)/MatchedSample
      SpendPerPersonChange       = 100*((SpendPerPersonTest-SpendPerPersonPre)/
                                         SpendPerPersonPre)
      SpendPerPersonLift         = 0
 
      list(
        Exposure                   = Exposure,
        Publisher                  = Publisher,
        Creative                   = Creative,
        Tactic                     = Tactic,
        MediaType                  = MediaType,
        Age                        = Age,
        Gender                     = Gender,
        Market                     = Market,
        PrePeriod                  = PrePeriod,
        PrePeriodNMC               = PrePeriodNMC,
        PrePeriodType              = PrePeriodType,
        CampaignPeriod             = CampaignPeriod,
        PostPeriod                 = PostPeriod,
        PostPeriodType             = PostPeriodType,
        TestPeriod                 = TestPeriod,
        Type                       = Type,
        Demo                       = Demo,
        Merchant                   = Merchant,
        MerchantKey                = MerchantKey,
        Freq                       = Freq,
        Freqmin                    = Freqmin,
        Freqmax                    = Freqmax,
        Sample                     = Sample, #Excel: take Sample and rename as MatchedSample
        MatchedSample              = MatchedSample,
        ESS                        = ESS, #NMC: delete ESS
        BuyersPre                  = BuyersPre, #NMC: rename Buyers_Pre
        BuyersTest                 = BuyersTest, #NMC: rename Buyers_Test
        BuyersChange               = BuyersChange, #NMC: rename Buyers_Change
        BuyersLift                 = BuyersLift, #NMC: rename Buyers_Lift
        PenetrationPre             = PenetrationPre, #NMC: rename Penetration_Pre
        PenetrationTest            = PenetrationTest , #NMC: rename Penetration_Test
        PenetrationChange          = PenetrationChange , #NMC: rename Penetration_Change
        PenetrationLift            = PenetrationLift, #NMC: rename Penetration_Lift   
        AvgTransactionsPre         = AvgTransactionsPre, #NMC: rename TransactionsPerBuyer_Pre
        AvgTransactionsTest        = AvgTransactionsTest , #NMC: rename TransactionsPerBuyer_Test
        AvgTransactionsChange      = AvgTransactionsChange , #NMC: rename TransactionsPerBuyer_Change
        AvgTransactionsLift        = AvgTransactionsLift, #NMC: rename TransactionsPerBuyer_Lift
        SpendPerTransactionsPre    = SpendPerTransactionsPre , #NMC: rename SpendperTransactions_Pre
        SpendPerTransactionsTest   = SpendPerTransactionsTest, #NMC: rename SpendperTransactions_Test
        SpendPerTransactionsChange = SpendPerTransactionsChange, #NMC: rename SpendperTransactions_Change
        SpendPerTransactionsLift   = SpendPerTransactionsLift, #NMC: rename SpendperTransactions_Lift
        AvgSpendPre                = AvgSpendPre, #NMC: rename SpendPerBuyer_Pre
        AvgSpendTest               = AvgSpendTest, #NMC: rename SpendPerBuyer_Test
        AvgSpendChange             = AvgSpendChange, #NMC: rename SpendPerBuyer_Change
        AvgSpendLift               = AvgSpendLift, #NMC: rename SpendPerBuyer_Lift
        SpendPerPerson_Pre         = SpendPerPersonPre, 
        SpendPerPerson_Test        = SpendPerPersonTest, 
        SpendPerPerson_Change      = SpendPerPersonChange, 
        SpendPerPerson_Lift        = SpendPerPersonLift, 
        TotalTransactions_Pre      = TotalTransactionsPre, 
        TotalTransactions_Test     = TotalTransactionsTest, 
        TotalTransactions_Change   = TotalTransactionsChange, 
        TotalTransactions_Lift     = TotalTransactionsLift,
        TotalSpend_Pre             = TotalSpendPre,
        TotalSpend_Test            = TotalSpendTest,
        TotalSpend_Change          = TotalSpendChange,
        TotalSpend_Lift            = TotalSpendLift,
        ShareCategoryPre           = ShareCategoryPre, #NMC: rename ShareCategory_Pre
        ShareCategoryTest          = ShareCategoryTest, #NMC: rename ShareCategory_Test
        ShareCategoryChange        = ShareCategoryChange, #NMC: rename ShareCategory_Change
        ShareCategoryLift          = ShareCategoryLift, #NMC: rename ShareCategory_Lift
        BuyersTotalPre             = BuyersTotalPre, #NMC: rename BuyersTotal_Pre
        BuyersTotalTest            = BuyersTotalTest, #NMC: rename BuyersTotal_Test
        BuyersTotal_Change         = BuyersTotalChange,
        BuyersTotal_Lift           = BuyersTotalLift
      )}]
    
    if (nrow(dataout) == 0) {
      dataout <- data.table("Exposure"                   = project
                           ,"Publisher"                  = publisher
                           ,"Creative"                   = creative
                           ,"Tactic"                     = tactic
                           ,"MediaType"                  = mediatype
                           ,"Age"                        = age
                           ,"Gender"                     = gender
                           ,"Market"                     = market
                           ,"PrePeriod"                  = predesc
                           ,"PrePeriodNMC"               = predescNMC
                           ,"PrePeriodType"              = pretypedesc
                           ,"CampaignPeriod"             = campaigndesc
                           ,"PostPeriod"                 = postdesc
                           ,"PostPeriodType"             = posttypedesc
                           ,"TestPeriod"                 = testdesc
                           ,"Type"                       = reporttype
                           ,"Demo"                       = demo
                           ,"Merchant"                   = merch
                           ,"MerchantKey"                = merchkey
                           ,"Freq"                       = desc
                           ,"Freqmin"                    = NA
                           ,"Freqmax"                    = NA
                           ,"Sample"                     = NA
                           ,"MatchedSample"              = NA
                           ,"ESS"                        = NA
                           ,"BuyersPre"                  = NA
                           ,"BuyersTest"                 = NA
                           ,"BuyersChange"               = NA
                           ,"BuyersLift"                 = NA
                           ,"PenetrationPre"             = NA
                           ,"PenetrationTest"            = NA
                           ,"PenetrationChange"          = NA
                           ,"PenetrationLift"            = NA
                           ,"AvgTransactionsPre"         = NA
                           ,"AvgTransactionsTest"        = NA
                           ,"AvgTransactionsChange"      = NA
                           ,"AvgTransactionsLift"        = NA
                           ,"SpendPerTransactionsPre"    = NA
                           ,"SpendPerTransactionsTest"   = NA
                           ,"SpendPerTransactionsChange" = NA
                           ,"SpendPerTransactionsLift"   = NA
                           ,"AvgSpendPre"                = NA
                           ,"AvgSpendTest"               = NA
                           ,"AvgSpendChange"             = NA
                           ,"AvgSpendLift"               = NA
                           ,"SpendPerPerson_Pre"         = NA
                           ,"SpendPerPerson_Test"        = NA
                           ,"SpendPerPerson_Change"      = NA
                           ,"SpendPerPerson_Lift"        = NA
                           ,"TotalTransactions_Pre"      = NA
                           ,"TotalTransactions_Test"     = NA
                           ,"TotalTransactions_Change"   = NA
                           ,"TotalTransactions_Lift"     = NA
                           ,"TotalSpend_Pre"             = NA
                           ,"TotalSpend_Test"            = NA
                           ,"TotalSpend_Change"          = NA
                           ,"TotalSpend_Lift"            = NA
                           ,"ShareCategoryPre"           = NA
                           ,"ShareCategoryTest"          = NA
                           ,"ShareCategoryChange"        = NA
                           ,"ShareCategoryLift"          = NA
                           ,"BuyersTotalPre"             = NA
                           ,"BuyersTotalTest"            = NA
                           ,"BuyersTotal_Change"         = NA
                           ,"BuyersTotal_Lift"           = NA)
    }
    
    return(dataout)
    
  }
  
  # Function - GenerateOutput
  GenerateOutput <- function(params,inputdata,weight) {
    prtime <- "pre"
    antime <- "test"
    expmin <- 1
    expmax <- params$exposuren
    #prfr <- params$period.agg.def.fr$pre
    #anfr <- params$period.agg.def.fr$test
    
    # define empty datalists to be used for rbind rows
    datalist.i <- 1 # starting from 1
    datalist <- list()

    # Loop through exposures
    for (expnum in (expmin:expmax)) {
      # expnum=1
      message(paste0('\n  Running aggregation for exposure variable: ',
                     params$exposure[expnum]))
      # Loop through the types of analyses
      for (types in 1:4){
        #types = 2
        # Loop through demo
        for (dems in 1:length(params$demolst)){
          #dems=1
          demovar  <- tolower(params$demolst[dems])
          demoname <- params$demodesclst[dems]
          #Loop through spend segments
          for (segs in 1:length(params$segmentlst)){
            #segs=1
            segm <- tolower(params$segmentlst[segs])
            segd <- params$segmentdesclst[segs]
            
            typn1 <- paste0("All ",segd," Buyers")
            typn2 <- paste0("New ",segd," Buyers")
            typn3 <- paste0("Existing ",segd," Buyers")
            typn4 <- paste0("Heavy ",segd," Buyers")
            
            # Where statement
            typst1 <- "(datain$sample == 1)"
            typst2 <- paste0('(datain$',segm,"_transyes_",prtime," == 0)")
            typst3 <- paste0('(datain$',segm,"_transyes_",prtime," > 0)")
            typst4 <- paste0('(datain$',segm,"_spend_",prtime,"_hml"," == 3)")
            
            log1 <- "(sample == 1)"
            log2 <- paste0('(',segm,"_transyes_",prtime," == 0)")
            log3 <- paste0('(',segm,"_transyes_",prtime," > 0)")
            log4 <- paste0('(',segm,"_spend_",prtime,"_hml"," == 3)") 
            
            # Overall
            message(paste0('  - Running aggregation for: demo ',params$demodesclst[dems],' / ',
                           eval(parse(text=paste0("typn",types))),' / Total'))
            message(paste0('      filter: ',paste("(sample == 1)",
                                                  eval(parse(text=paste0("log",types))),
                                                  paste0('(',demovar," == 1)"),
                                                  paste0('(!is.na(',tolower(params$expyes[expnum]),"))"),
                                                  sep = " & ")))
            outputsummary.overall <- aggreg(project = params$exposure[expnum],
                                            
                                            predesc = params$period.agg.def.fr$pre,
                                             preper = prtime,
                                           testdesc = params$period.agg.def.fr$test,
                                         reporttype = eval(parse(text=paste0("typn",types))),
                                             datain = inputdata,
                                               demo = demoname,           
                                            segment = segm,
                                              merch = segd,
                                           expcount = tolower(params$explist[expnum]),
                                               desc = "Total",
                                         wherestate = paste("(datain$sample == 1)",
                                                            eval(parse(text=paste0("typst",types))),
                                                            paste0('(datain$',demovar," == 1)"),
                                                            paste0('(!is.na(datain$',tolower(params$expyes[expnum]),"))"),
                                                            sep = " & "),
                                          weightvar = weight,
                                            testper = antime,            
                                           Totalvar = tolower(params$totalvar))
            
            datalist[[datalist.i]] <- outputsummary.overall
            
            # Exposed vs Unexposed
            nameslst <- c("Unexposed","Exposed")
            for (ex in 0:1) {
              #ex=0
              names <- nameslst[ex+1]
              message(paste0('  - Running aggregation for: demo ',params$demodesclst[dems],' / ',
                             eval(parse(text=paste0("typn",types))),' / ',names))
              message(paste0('      filter: ',paste("(sample == 1)",
                                                    paste0('(',tolower(params$expyes[expnum])," == ",ex,')'),
                                                    eval(parse(text=paste0("log",types))),
                                                    paste0('(',demovar," == 1)"),
                                                    sep = " & ")))
              outputsummary.exp <- aggreg(project = params$exposure[expnum],
                                          predesc = params$period.agg.def.fr$pre,
                                           preper = prtime,
                                         testdesc = params$period.agg.def.fr$test,
                                       reporttype = eval(parse(text=paste0("typn",types))),
                                           datain = inputdata,
                                             demo = demoname,           
                                          segment = segm,
                                            merch = segd,
                                         expcount = tolower(params$explist[expnum]),
                                             desc = names,
                                       wherestate = paste("(datain$sample == 1)",
                                                    paste0('(datain$',tolower(params$expyes[expnum])," == ",ex,')'),
                                                    eval(parse(text=paste0("typst",types))),
                                                    paste0('(datain$',demovar," == 1)"),
                                                    sep = " & "),
                                        weightvar = weight,
                                          testper = antime,            
                                         Totalvar = tolower(params$totalvar))
              
              datalist[[datalist.i+ex+1]] <- outputsummary.exp
            }
            
            # Exposed HML
            nameslst <- c("Low Exposure","Medium Exposure","High Exposure")
            for (f in 1:3) {
              #f=1
              names <- nameslst[f]
              message(paste0('  - Running aggregation for: demo ',params$demodesclst[dems],' / ',
                             eval(parse(text=paste0("typn",types))),' / ',names))
              message(paste0('      filter: ',paste("(sample == 1)",
                                                    paste0('(',tolower(params$expfreq[expnum])," == ",f,')'),
                                                    eval(parse(text=paste0("log",types))),
                                                    paste0('(',demovar," == 1)"),
                                                    sep = " & ")))
              outputsummary.hml <- aggreg(project = params$exposure[expnum],
                                          predesc = params$period.agg.def.fr$pre,
                                           preper = prtime,
                                         testdesc = params$period.agg.def.fr$test,
                                       reporttype = eval(parse(text=paste0("typn",types))),
                                           datain = inputdata,
                                             demo = demoname,           
                                          segment = segm,
                                            merch = segd,
                                         expcount = tolower(params$explist[expnum]),
                                             desc = names,
                                       wherestate = paste("(datain$sample == 1)",
                                                          paste0('(datain$',tolower(params$expfreq[expnum])," == ",f,')'),
                                                          eval(parse(text=paste0("typst",types))),
                                                          paste0('(datain$',demovar," == 1)"),
                                                          sep = " & "),
                                        weightvar = weight,
                                          testper = antime,            
                                         Totalvar = tolower(params$totalvar))
              
              datalist[[datalist.i+f-1+3]] <- outputsummary.hml
            }
            
            # assuming we have overall, exposed vs unexposed,
            # exposed hml = 6 types of exposure cuts
            datalist.i <- datalist.i + 6 
            
            # End of spend segments loop          
          }
          # End of demo loop
        }
        # End of types of analyses loop
      }
      # End of exposures loop
    }
    # append rows and generate the output dataset
    dataout <- data.table::rbindlist(datalist)
    return(dataout)

  }
  
  # Function - GenerateOutput
  # inputdata=argus_recoded_wtd
  # weight=weightcol
  GenerateOutput_NMC <- function (params,inputdata,weight) {
    prtime <- "pre"
    antime <- "test"
    expmin <- 1
    expmax <- params$exposuren
    #prfr <- params$period.agg.def.fr$pre
    #anfr <- params$period.agg.def.fr$test
    
    # define empty datalists to be used for rbind rows
    datalist.i <- 1 # starting from 1
    datalist = list()
    
    # Loop through exposures
    for (expnum in (expmin:expmax)) {
      #expnum <- 16
      message(paste0('\n  Running aggregation for exposure variable: ',
                     params$exposure[expnum]))
      publishername <- params$publisher[expnum]
      creativename <- params$creative[expnum]
      tacticname <- params$tactic[expnum]
      mediatypename <- params$mediatype[expnum]
      marketname <- params$market[expnum]
      
      # Loop through the types of analyses
      for (types in 1:4) {
        #types <- 4
        # Loop through demo
        for (dems in 1:length(params$demolst)) {
          #dems <- 1
          demovar  <- tolower(params$demolst[dems])
          demoname <- params$demodesclst[dems]
          agename <- params$agedesc[dems]
          gendername <- params$genderdesc[dems]
          
          #Loop through spend segments
          for (segs in 1:length(params$segmentlst)) {
            #segs <- 1
            segm <- tolower(params$segmentlst[segs])
            segd <- params$segmentdesclst[segs]
            segkey <- params$segmentdeslstkey[segs]
            
            typn1 <- paste0("All ",segd," Buyers")
            typn2 <- paste0("New ",segd," Buyers")
            typn3 <- paste0("Existing ",segd," Buyers")
            typn4 <- paste0("Heavy ",segd," Buyers")
            
            # Where statement
            typst1 <- "(datain$sample == 1)"
            typst2 <- paste0('(datain$',segm,"_transyes_",prtime," == 0)")
            typst3 <- paste0('(datain$',segm,"_transyes_",prtime," > 0)")
            typst4 <- paste0('(datain$',segm,"_spend_",prtime,"_hml"," == 3)")
            
            log1 <- "(sample == 1)"
            log2 <- paste0('(',segm,"_transyes_",prtime," == 0)")
            log3 <- paste0('(',segm,"_transyes_",prtime," > 0)")
            log4 <- paste0('(',segm,"_spend_",prtime,"_hml"," == 3)")
            # We really need to standardize the metrics name!!!!!!!! e.g, spend vs. Spend
            
            # Overall
            message(paste0('  - Running aggregation for: demo ',params$demodesclst[dems],' / ',
                           eval(parse(text=paste0("typn",types))),' / Total'))
            message(paste0('      filter: ',paste("(sample == 1)",
                                                  eval(parse(text=paste0("log",types))),
                                                  paste0('(',demovar," == 1)"),
                                                  paste0('(!is.na(',tolower(params$expyes[expnum]),"))"),
                                                  sep = " & ")))
            outputsummary.overall <- aggreg_NMC(project = params$exposure[expnum],
                                              publisher = publishername,
                                               creative = creativename,
                                                 tactic = tacticname,
                                              mediatype = mediatypename,
                                                 market = marketname,
                                                    age = agename,
                                                 gender = gendername,
                                              
                                                predesc = params$period.agg.def.fr$pre,
                                             predescNMC = params$prefr,
                                            pretypedesc = params$prefrtype,
                                           campaigndesc = params$testfr,
                                               postdesc = params$postfr,
                                           posttypedesc = params$postfrtype, 
                                               testdesc = params$tspsfr,
                                              #testdesc = params$period.agg.def.fr$test,
                                                
                                                 preper = prtime,
                                             reporttype = eval(parse(text=paste0("typn",types))),
                                                 datain = inputdata,
                                                   demo = demoname,           
                                                segment = segm,
                                                  merch = segd,
                                           
                                               merchkey = segkey,
                                           
                                               expcount = tolower(params$explist[expnum]),
                                                   desc = "Total",
                                             wherestate = paste("(datain$sample == 1)",
                                                                eval(parse(text=paste0("typst",types))),
                                                                paste0('(datain$',demovar," == 1)"),
                                                                paste0('(!is.na(datain$',tolower(params$expyes[expnum]),"))"),
                                                                sep = " & "),
                                              weightvar = weight,
                                                testper = antime,            
                                               Totalvar = tolower(params$totalvar)
                                               )
            datalist[[datalist.i]] <- outputsummary.overall
            
            # Exposed vs Unexposed
            nameslst <- c("Unexposed","Exposed")
            for (ex in 0:1) {
              #ex<-0
              names <- nameslst[ex+1]
              message(paste0('  - Running aggregation for: demo ',params$demodesclst[dems],' / ',
                             eval(parse(text=paste0("typn",types))),' / ',names))
              message(paste0('      filter: ',paste("(sample == 1)",
                                                    paste0('(',tolower(params$expyes[expnum])," == ",ex,')'),
                                                    eval(parse(text=paste0("log",types))),
                                                    paste0('(',demovar," == 1)"),
                                                    sep = " & ")))
              outputsummary.exp <- aggreg_NMC(project = params$exposure[expnum],
                                            publisher = publishername,
                                             creative = creativename,
                                               tactic = tacticname,
                                            mediatype = mediatypename,
                                               market = marketname,
                                                  age = agename,
                                               gender = gendername,
                                            
                                              predesc = params$period.agg.def.fr$pre,
                                           predescNMC = params$prefr,
                                          pretypedesc = params$prefrtype,
                                         campaigndesc = params$testfr,
                                             postdesc = params$postfr,
                                         posttypedesc = params$postfrtype, 
                                             testdesc = params$tspsfr,
                                            #testdesc = params$period.agg.def.fr$test,
                                            
                                               preper = prtime,
                                           reporttype = eval(parse(text=paste0("typn",types))),
                                               datain = inputdata,
                                                 demo = demoname,           
                                              segment = segm,
                                                merch = segd,
                                           
                                           merchkey = segkey,
                                           
                                             expcount = tolower(params$explist[expnum]),
                                                 desc = names,
                                           wherestate = paste("(datain$sample == 1)",
                                                              paste0('(datain$',tolower(params$expyes[expnum])," == ",ex,')'),
                                                              eval(parse(text=paste0("typst",types))), 
                                                              paste0('(datain$',demovar," == 1)"),
                                                              sep = " & "),
                                            weightvar = weight,
                                              testper = antime,            
                                             Totalvar = tolower(params$totalvar)
                                             )
              datalist[[datalist.i+ex+1]] <- outputsummary.exp
            }
            
            # Exposed HML
            nameslst <- c("Low Exposure","Medium Exposure","High Exposure")
            for (f in 1:3) {
              #f <- 2
              names <- nameslst[f]
              message(paste0('  - Running aggregation for: demo ',params$demodesclst[dems],' / ',
                             eval(parse(text=paste0("typn",types))),' / ',names))
              message(paste0('      filter: ',paste("(sample == 1)",
                                                    paste0('(',tolower(params$expfreq[expnum])," == ",f,')'),
                                                    eval(parse(text=paste0("log",types))),
                                                    paste0('(',demovar," == 1)"),
                                                    sep = " & ")))
              outputsummary.hml <- aggreg_NMC(project = params$exposure[expnum],
                                            publisher = publishername,
                                             creative = creativename,
                                               tactic = tacticname,
                                            mediatype = mediatypename,
                                               market = marketname,
                                                  age = agename,
                                               gender = gendername,
                                            
                                              predesc = params$period.agg.def.fr$pre,
                                           predescNMC = params$prefr,
                                          pretypedesc = params$prefrtype,
                                         campaigndesc = params$testfr,
                                             postdesc = params$postfr,
                                         posttypedesc = params$postfrtype, 
                                             testdesc = params$tspsfr,
                                            #testdesc = params$period.agg.def.fr$test,
                                            
                                               preper = prtime,
                                           reporttype = eval(parse(text=paste0("typn",types))),
                                               datain = inputdata,
                                                 demo = demoname,           
                                              segment = segm,
                                                merch = segd,
                                           
                                           merchkey = segkey,
                                           
                                             expcount = tolower(params$explist[expnum]),
                                                 desc = names,
                                           wherestate = paste("(datain$sample == 1)",
                                                              paste0('(datain$',tolower(params$expfreq[expnum])," == ",f,')'),
                                                              eval(parse(text=paste0("typst",types))),
                                                              paste0('(datain$',demovar," == 1)"),
                                                              sep = " & "),
                                            weightvar = weight,
                                              testper = antime,            
                                             Totalvar = tolower(params$totalvar)
                                             )
              datalist[[datalist.i+f-1+3]] <- outputsummary.hml
            }
            
            datalist.i <- datalist.i + 6 # assuming we have overall, exposed vs unexposed,exposed hml = 6 types of exposure cuts
            
            # End of spend segments loop          
          }
          # End of demo loop
        }
        # End of types of analyses loop
      }
      # End of exposures loop
    }
    # append rows and generate the output dataset
    dataout <- data.table::rbindlist(datalist)
    return(dataout)
  }
  
  # Function to replace Inf with NA and remove obs with total buyer # < 50
  #inputdata<-copy(outputsummary)
  deleteflag <- function(inputdata) {
    # Replace Inf with NA
    invisible(lapply(names(inputdata),function(.name) set(inputdata, 
              which(is.infinite(inputdata[[.name]])), j = .name,value =NA)))
    
    # Remove obs with total buyer # < 50
    ifr.vec <- c("BuyersPre"
                 #, "BuyersTest"
                 ,"BuyersChange"
                 , "PenetrationPre"
                 , "PenetrationTest"
                 , "PenetrationChange"
                 , "AvgTransactionsPre"
                 , "AvgTransactionsTest"
                 , "AvgTransactionsChange"
                 , "SpendPerTransactionsPre"
                 , "SpendPerTransactionsTest"
                 , "SpendPerTransactionsChange"
                 , "AvgSpendPre"
                 , "AvgSpendTest"
                 , "AvgSpendChange"
                 , "ShareCategoryPre"
                 , "ShareCategoryTest"
                 , "ShareCategoryChange")
    
    # Force buyer > 50 to missing
    inputdata[
      which((substr(inputdata$Type,1,3) != "New") &
            ((inputdata$BuyersTotalPre < 50) | (inputdata$BuyersTotalTest < 50)))
      , (ifr.vec) := NA
      ]
    
    inputdata[
      which((substr(inputdata$Type,1,3) == "New") & (inputdata$BuyersTotalTest < 50))
      , (ifr.vec) := NA
      ]
    
    return(inputdata)
  }
  
  # Function to validate "comparison" dataset against "model" dataset.
  validate_23 <- function(params,filename_list,key_column_list) {
    
    path <- params$path
    dump_diff_file <- params$dump_diff_file
    
    if (!file.exists(paste0(path,'/Validation'))) { 
      dir.create(paste0(path,'/Validation')) 
    }
    
    for (j in 1:length(filename_list)) {
      #j<-2
      ModelFileName <- filename_list[[j]][1]
      dot_pos <- tail(gregexpr('.',ModelFileName,fixed=TRUE)[[1]],n=1)
      ModelFileType <- substr(ModelFileName,dot_pos+1,nchar(ModelFileName))
      
      if (file.exists(ModelFileName)) {
        
        key_column <- key_column_list[[j]]
        
        # Find the matching file in the comparison folder
        ComparisonFileName <- filename_list[[j]][2]
        dot_pos <- tail(gregexpr('.',ComparisonFileName,fixed=TRUE)[[1]],n=1)
        ComparisonFileType <- substr(ComparisonFileName,dot_pos+1,
                                     nchar(ComparisonFileName))
        
        message(paste0('\n  Validating ',ComparisonFileName))
        message(paste0('  against ',ModelFileName))
        
        # Output folder and file names
        outfolder <- paste0(path,'/Validation')
        filename <- substr(ComparisonFileName,1,dot_pos-1)
        char_pos <- tail(gregexpr('/',filename,fixed=TRUE)[[1]],n=1)
        filename <- substr(filename,char_pos+1,nchar(filename))
        filename <- paste0('/diff_',filename)
        outname <- base::paste0(outfolder,filename)
        
        # Upload files
        if (ModelFileType == 'sas7bdat') {
          Modelfile <- haven::read_sas(ModelFileName)
        } else if (ModelFileType == 'csv') {
          Modelfile <- read.csv(file=ModelFileName,stringsAsFactors=F)
        } else if (ModelFileType == 'RData') {
          Modelfile <- loadRData_noalloc(ModelFileName)
        } else if (ModelFileType == 'xlsx') {
          print('  - Please, add capability to read xlsx files.')
        }
        if (!('data.table' %in% class(Modelfile))) {
          Modelfile <- as.data.table(Modelfile)
        }
        colnames(Modelfile) <- base::tolower(base::colnames(Modelfile))
        
        if (nrow(Modelfile) == 0) {
          
          if (ComparisonFileType == 'sas7bdat') {
            Comparisonfile <- haven::read_sas(ComparisonFileName)
          } else if (ComparisonFileType == 'csv') {
            Comparisonfile <- read.csv(file=ComparisonFileName)
          } else if (ComparisonFileType == 'RData') {
            Comparisonfile <- loadRData_noalloc(ComparisonFileName)
          } else if (ComparisonFileType == 'xlsx') {
            print('  - Please, add capability to read xlsx files.')
          }
          colnames(Comparisonfile) <- base::tolower(base::colnames(Comparisonfile))
          
          if (nrow(Comparisonfile) == 0) {
            
            message('  - No discrepancies were found.')
            
          } else {
            
            message('  - Discrepancies were found.')
            message(paste0('    Dimensions of model dataset were ',
                           toString(nrow(Modelfile)),' x ',
                           toString(ncol(Modelfile))))
            message(paste0('    while dimensions of comparison dataset were ',
                           toString(nrow(Comparisonfile)),' x ',
                           toString(ncol(Comparisonfile))))
            
          }
          
        } else {
          
          if (ComparisonFileType == 'sas7bdat') {
            Comparisonfile <- haven::read_sas(ComparisonFileName)
          } else if (ComparisonFileType == 'csv') {
            Comparisonfile <- read.csv(file=ComparisonFileName)
          } else if (ComparisonFileType == 'RData') {
            Comparisonfile <- loadRData_noalloc(ComparisonFileName)
          } else if (ComparisonFileType == 'xlsx') {
            print('  - Please, add capability to read xlsx files.')
          }
          if (!('data.table' %in% class(Comparisonfile))) {
            Comparisonfile <- as.data.table(Comparisonfile)
          }
          colnames(Comparisonfile) <- base::tolower(base::colnames(Comparisonfile))
          
          if (nrow(Comparisonfile) == 0) {
            
            message('  - Discrepancies were found.')
            message(paste0('    Dimensions of model dataset were ',
                           toString(nrow(Modelfile)),' x ',
                           toString(ncol(Modelfile))))
            message(paste0('    while dimensions of comparison dataset were ',
                           toString(nrow(Comparisonfile)),' x ',
                           toString(ncol(Comparisonfile))))
            
          } else {
            
            # For Excel-macro output (j=1), change variables to numeric
            if (j == 1) {
              ifr.vec <- c('matchedsample','ess','buyerspre','buyerstest',
                           'buyerschange', 'penetrationpre','penetrationtest',
                           'penetrationchange','avgtransactionspre',
                           'avgtransactionstest','avgtransactionschange',
                           'spendpertransactionspre','spendpertransactionstest',
                           'spendpertransactionschange','avgspendpre','avgspendtest',
                           'avgspendchange','sharecategorypre','sharecategorytest',
                           'sharecategorychange','buyerstotalpre','buyerstotaltest')
              ifr.vec <- get_indexes(ifr.vec,Modelfile)
              for (icol in ifr.vec) {
                #icol = ifr.vec[2]
                set(Modelfile, j = icol,
                    value = as.numeric(gsub(',','',Modelfile[[icol]])))
              }
              
              # # Remove obs with total buyer # < 50
              # ifr.vec <- tolower(c("BuyersPre"
              #              #, "BuyersTest"
              #              , "BuyersChange"
              #              , "PenetrationPre"
              #              , "PenetrationTest"
              #              , "PenetrationChange"
              #              , "AvgTransactionsPre"
              #              , "AvgTransactionsTest"
              #              , "AvgTransactionsChange"
              #              , "SpendPerTransactionsPre"
              #              , "SpendPerTransactionsTest"
              #              , "SpendPerTransactionsChange"
              #              , "AvgSpendPre"
              #              , "AvgSpendTest"
              #              , "AvgSpendChange"
              #              , "ShareCategoryPre"
              #              , "ShareCategoryTest"
              #              , "ShareCategoryChange"))
              # #ifr.vec <- c("buyerspre")
              # Modelfile[
              #   which((substr(Modelfile$type,1,3) != "New") &
              #           ((Modelfile$buyerstotalpre < 50) | (Modelfile$buyerstotaltest < 50)))
              #   , (ifr.vec) := NA
              #   ]
              # Modelfile[
              #   which((substr(Modelfile$type,1,3) == "New") & 
              #           (Modelfile$buyerstotaltest < 50))
              #   , (ifr.vec) := NA
              #   ]
            }
            
            # Remove obs with total buyer # < 50
            # if (j == 2) {
            #   ifr.vec <- c('buyers_pre','buyers_change','penetration_pre',
            #                'penetration_test','penetration_change',
            #                'transactionsperbuyer_pre','transactionsperbuyer_test',
            #                'transactionsperbuyer_change','spendpertransactions_pre',
            #                'spendpertransactions_test','spendpertransactions_change',
            #                'spendperbuyer_pre','spendperbuyer_test','spendperbuyer_change',
            #                'sharecategory_pre','sharecategory_test','sharecategory_change')
            #   Modelfile[
            #     which((substr(Modelfile$type,1,3) != "New") &
            #             ((Modelfile$buyerstotal_pre < 50) | (Modelfile$buyerstotal_test < 50)))
            #     , (ifr.vec) := NA
            #     ]
            #   Modelfile[
            #     which((substr(Modelfile$type,1,3) == "New") & 
            #             (Modelfile$buyerstotal_test < 50))
            #     , (ifr.vec) := NA
            #     ]
            # }
            
            # Replace 0 with NA in Modelfile
            for (i in seq_len(ncol(Modelfile))) { 
              set(Modelfile, which(Modelfile[[i]] == 0), i, NA)
            }
            
            # For McDonalds SAS NMC output
            if ((params$path == 'E:/McDonalds') && (j == 2)) {
              Modelfile[,`:=`(exposure = ifelse(Modelfile$exposure == 
              'McDonalds - Sports Rotational Targeting Exposures (10/03/2017 - 10/31/2017)',
              'McDonalds - Sports Rotational Targeting (10/03/2017 - 10/31/2017)',
              Modelfile$exposure))]
              Modelfile[,`:=`(preperiod = ifelse(Modelfile$preperiod == 
                                                   '0/03/16 - 10/02/17',
                                                  '10/03/16 - 10/02/17',
                                                 Modelfile$preperiod))]
            }
            
            # Replace 0 with NA in Comparisonfile
            for (i in seq_len(ncol(Comparisonfile))) { 
              set(Comparisonfile, which(Comparisonfile[[i]] == 0), i, NA) 
            }
            
            # Compare files
            validate_dt_file(Modelfile,Comparisonfile,key_column,outname,
                             dump_diff_file)
            
          }
          
        }
        
        rm(Modelfile)
        rm(Comparisonfile)
        foo <- gc()
        
      } else {
        
        message(paste0('  - ',ModelfileName,' does not exist.'))
        
      }
      
    }
    
  }
  
}
################################################################################
############################# Main Function ####################################
################################################################################
{
  
  main_23 <- function(params,argus_recoded_wtd) {
    
    message(paste0('\n  Memory usage is: ',memory.size(max=FALSE),' MB'))
    
    # 1. Fill in Parameters and generate reports (wtd and unwtd)
    
    if (params$weightmetrics == 1) {
      # wtd
      message('\n  Running aggregation using weighted unexposed group.')
      weightcol <- params$rimweightvar
      outputname <- '_wtd'
    } else {
      # unweighted
      message('\n  Running aggregation using unweighted unexposed group.')
      weightcol <- 'weight'
      outputname <- '_unwtd'
    }
      
    if (params$NMCoutput) {
      outputsummary <- GenerateOutput_NMC(params=params,
                                          inputdata=argus_recoded_wtd,
                                          weight=weightcol
                                          )
    } else {
      outputsummary <- GenerateOutput(params=params,
                                      inputdata=argus_recoded_wtd,
                                      weight=weightcol
                                     )
    }
    outputsummary[is.na(outputsummary)] <- NA
    for (j in 1:ncol(outputsummary)) {
      set(outputsummary, which(is.infinite(outputsummary[[j]])), j, NA)
    }
    #outputsummary[is.na(outputsummary)] <- 'A'
    if (params$NMCoutput) {
      # Modify dataset for NMC output
      outputsummary.nmc <- copy(outputsummary)
      outputsummary.nmc[, c("ESS","PrePeriod"):=NULL]
      setnames(outputsummary.nmc, 
               old = c('PrePeriodNMC','BuyersPre','BuyersTest','BuyersChange','BuyersLift',
                       'PenetrationPre','PenetrationTest','PenetrationChange',
                       'PenetrationLift','AvgTransactionsPre',
                       'AvgTransactionsTest','AvgTransactionsChange',
                       'AvgTransactionsLift','SpendPerTransactionsPre',
                       'SpendPerTransactionsTest','SpendPerTransactionsChange',
                       'SpendPerTransactionsLift','AvgSpendPre',
                       'AvgSpendTest','AvgSpendChange','AvgSpendLift',
                       'ShareCategoryPre','ShareCategoryTest','ShareCategoryChange',
                       'ShareCategoryLift','BuyersTotalPre','BuyersTotalTest'), 
               new = c('PrePeriod','Buyers_Pre','Buyers_Test','Buyers_Change','Buyers_Lift',
                       'Penetration_Pre','Penetration_Test','Penetration_Change',
                       'Penetration_Lift','TransactionsPerBuyer_Pre',
                       'TransactionsPerBuyer_Test','TransactionsPerBuyer_Change',
                       'TransactionsPerBuyer_Lift','SpendperTransactions_Pre',
                       'SpendperTransactions_Test','SpendperTransactions_Change',
                       'SpendperTransactions_Lift','SpendPerBuyer_Pre',
                       'SpendPerBuyer_Test','SpendPerBuyer_Change','SpendPerBuyer_Lift',
                       'ShareCategory_Pre','ShareCategory_Test','ShareCategory_Change',
                       'ShareCategory_Lift','BuyersTotal_Pre','BuyersTotal_Test')
               )
      
      # Write NMC output
      message(paste0('\n  Writing ',params$outputpath,"/",tolower(params$proj),
                       "_outputsummary",outputname,"_nodelete_NMC.csv"))
      write.csv(outputsummary.nmc,paste0(params$outputpath,"/",tolower(params$proj),
                                         "_outputsummary",outputname,"_nodelete_NMC.csv"),
                row.names=FALSE)
      rm(outputsummary.nmc)
      foo <- gc()
        
      # Delete columns that are not needed for excel macro
      # (take Sample and rename as MatchedSample)
      outputsummary.excel <- copy(outputsummary[,c(
        "Exposure","PrePeriod","TestPeriod","Type","Demo","Freq","Merchant",
        "Freqmin","Freqmax","Sample","ESS","BuyersPre","BuyersTest",
        "BuyersChange","PenetrationPre","PenetrationTest","PenetrationChange",
        "AvgTransactionsPre","AvgTransactionsTest","AvgTransactionsChange",
        "SpendPerTransactionsPre","SpendPerTransactionsTest",
        "SpendPerTransactionsChange","AvgSpendPre","AvgSpendTest","AvgSpendChange",
        "ShareCategoryPre","ShareCategoryTest","ShareCategoryChange",
        "BuyersTotalPre","BuyersTotalTest"),with=F])
      colnames(outputsummary.excel)[colnames(outputsummary.excel)=="Sample"] = 'MatchedSample'
        
      # Reset PrePeriod and TestPeriod
      #outputsummary.excel[ , PrePeriod := params$period.agg.def.fr$pre]
      outputsummary.excel[ , TestPeriod := params$period.agg.def.fr$test]
        
      # Write output for Excel macro
      message(paste0('\n  Writing ',params$outputpath,"/",tolower(params$proj),
                     "_outputsummary",outputname,"_nodelete.csv"))
      write.csv(outputsummary.excel,paste0(params$outputpath,"/",
                                           tolower(params$proj),"_outputsummary",
                                           outputname,"_nodelete.csv"),
                row.names=FALSE)
      rm(outputsummary.excel)
      foo <- gc()
      
    } else {
      
      # Write output for Excel macro
      message(paste0('\n  Writing ',params$outputpath,"/",tolower(params$proj),
                     "_outputsummary",outputname,"_nodelete.csv"))
      write.csv(outputsummary,paste0(params$outputpath,"/",tolower(params$proj),
                                     "_outputsummary",outputname,"_nodelete.csv"),
                row.names=FALSE)
      if (params$mod_23$val) {
        message(paste0('\n  Writing ',params$datapath,'/',tolower(params$proj),
                       '_outputsummary',outputname,'_nodelete.RData'))
        save(outputsummary,file=paste0(params$datapath,"/",tolower(params$proj),
                                       "_outputsummary",outputname,"_nodelete.RData"))
      }
    }
      
    # Remove obs with total buyer < 50
    message('\n  Removing observations with total_buyer < 50.')
    #outputsummary.delete <- deleteflag(inputdata=copy(outputsummary))
    outputsummary <- deleteflag(inputdata=outputsummary)
      
    if (params$NMCoutput) {
      # Modify dataset for NMC output
      outputsummary.nmc <- copy(outputsummary)
      outputsummary.nmc[, c("ESS","PrePeriod"):=NULL]
      setnames(outputsummary.nmc, 
               old = c('PrePeriodNMC','BuyersPre','BuyersTest','BuyersChange','BuyersLift',
                       'PenetrationPre','PenetrationTest','PenetrationChange',
                       'PenetrationLift','AvgTransactionsPre',
                       'AvgTransactionsTest','AvgTransactionsChange',
                       'AvgTransactionsLift','SpendPerTransactionsPre',
                       'SpendPerTransactionsTest','SpendPerTransactionsChange',
                       'SpendPerTransactionsLift','AvgSpendPre',
                       'AvgSpendTest','AvgSpendChange','AvgSpendLift',
                       'ShareCategoryPre','ShareCategoryTest','ShareCategoryChange',
                       'ShareCategoryLift','BuyersTotalPre','BuyersTotalTest'), 
               new = c('PrePeriod','Buyers_Pre','Buyers_Test','Buyers_Change','Buyers_Lift',
                       'Penetration_Pre','Penetration_Test','Penetration_Change',
                       'Penetration_Lift','TransactionsPerBuyer_Pre',
                       'TransactionsPerBuyer_Test','TransactionsPerBuyer_Change',
                       'TransactionsPerBuyer_Lift','SpendperTransactions_Pre',
                       'SpendperTransactions_Test','SpendperTransactions_Change',
                       'SpendperTransactions_Lift','SpendPerBuyer_Pre',
                       'SpendPerBuyer_Test','SpendPerBuyer_Change','SpendPerBuyer_Lift',
                       'ShareCategory_Pre','ShareCategory_Test','ShareCategory_Change',
                       'ShareCategory_Lift','BuyersTotal_Pre','BuyersTotal_Test')
              )
      
      # Write NMC output
      message(paste0('\n  Writing ',params$outputpath,"/",tolower(params$proj),
                     "_outputsummary",outputname,"_NMC.csv"))
      write.csv(outputsummary.nmc,paste0(params$outputpath,"/",tolower(params$proj),
                                         "_outputsummary",outputname,"_NMC.csv"),
                row.names=FALSE)
      
      message(paste0('\n  Writing ',params$datapath,'/',tolower(params$proj),
                     '_outputsummary',outputname,'_NMC.RData'))
      save(outputsummary.nmc,file=paste0(params$datapath,"/",tolower(params$proj),
                                         "_outputsummary",outputname,"_NMC.RData"))
      
      rm(outputsummary.nmc)
      foo <- gc()
      
      # Delete columns that are not needed for excel macro
      # (take Sample and rename as MatchedSample)
      outputsummary.excel <- copy(outputsummary[,c(
        "Exposure","PrePeriod","TestPeriod","Type","Demo","Freq","Merchant",
        "Freqmin","Freqmax","Sample","ESS","BuyersPre","BuyersTest",
        "BuyersChange","PenetrationPre","PenetrationTest","PenetrationChange",
        "AvgTransactionsPre","AvgTransactionsTest","AvgTransactionsChange",
        "SpendPerTransactionsPre","SpendPerTransactionsTest",
        "SpendPerTransactionsChange","AvgSpendPre","AvgSpendTest","AvgSpendChange",
        "ShareCategoryPre","ShareCategoryTest","ShareCategoryChange",
        "BuyersTotalPre","BuyersTotalTest"),with=F])
      colnames(outputsummary.excel)[colnames(outputsummary.excel)=="Sample"] = 'MatchedSample'
      
      # Reset PrePeriod and TestPeriod
      #outputsummary.excel[ , PrePeriod := params$period.agg.def.fr$pre]
      outputsummary.excel[ , TestPeriod := params$period.agg.def.fr$test]
      
      # Write output for Excel macro
      message(paste0('\n  Writing ',params$outputpath,"/",tolower(params$proj),
                       "_outputsummary",outputname,".csv"))
      write.csv(outputsummary.excel,paste0(params$outputpath,"/",
                                           tolower(params$proj),
                                           "_outputsummary",outputname,".csv"),
                row.names=FALSE)
      if (params$mod_23$val) {
        message(paste0('\n  Writing ',params$datapath,'/',tolower(params$proj),
                       '_outputsummary',outputname,'.RData'))
        save(outputsummary.excel,file=paste0(params$datapath,"/",tolower(params$proj),
                                             "_outputsummary",outputname,".RData"))
      }
      rm(outputsummary.excel)
      foo <- gc()
      
    } else {
      
      # Write output for Excel macro
      message(paste0('\n  Writing ',params$outputpath,"/",tolower(params$proj),
                     "_outputsummary",outputname,".csv"))
      write.csv(outputsummary,paste0(params$outputpath,"/",tolower(params$proj),
                                     "_outputsummary",outputname,".csv"),
                row.names=FALSE)
      if (params$mod_23$val) {
        message(paste0('\n  Writing ',params$datapath,'/',tolower(params$proj),
                       '_outputsummary',outputname,'.RData'))
        save(outputsummary,file=paste0(params$datapath,"/",tolower(params$proj),
                                       "_outputsummary",outputname,".RData"))
      }
    }
    rm(outputsummary)
    foo <- gc()
    message(paste0('\n  Memory usage is: ',memory.size(max=FALSE),' MB'))
    
    # Validation of output
    if (params$mod_23$val) {
      
      # message(paste0('\n  Writing ',params$datapath,'/outputsummary.wtd.nodelete.RData'))
      # save(outputsummary.wtd,file=paste0(params$datapath,"/outputsummary.wtd.nodelete.RData"))
      # 
      # message(paste0('\n  Writing ',params$datapath,'/outputsummary.wtd.delete.RData'))
      # save(outputsummary.wtd.delete,file=paste0(params$datapath,"/outputsummary.wtd.delete.RData"))
      
      # The list of names of files to compare, in pairs (first is always the model file,
      # and second is always the comparison file)
      
      # For each filename in filename_list, provide the name of the column(s) that
      # identify each unique row
      # Ex. key_column_list <- list('respondentid',
      #                             c('hhid','personid'))
      if (params$NMCoutput) {
        if (params$path == 'E:/McDonalds') {
          filename_list <- list(c(paste0(params$val_dir,'/NMC/Current_Output_for_ExcelMacro/',
                                         tolower(params$proj),'_outputsummary.csv'),
                                  paste0(params$datapath,"/",tolower(params$proj),
                                         "_outputsummary",outputname,".RData"))
                               ,c(paste0(params$val_dir,'/NMC/NMC_Ouput/',tolower(params$proj),
                                         '_outputsummary.csv'),
                                  paste0(params$datapath,"/",tolower(params$proj),
                                         "_outputsummary",outputname,"_NMC.RData"))
                               )
          key_column_list <- list(c('exposure','type','demo','freq')
                                 ,c('exposure','type','demo','freq'))
        } else {
          filename_list <- list(c(paste0(params$val_dir,'/Output/',tolower(params$proj),
                                         '_outputsummary.csv'),
                                  paste0(params$datapath,"/",tolower(params$proj),
                                         "_outputsummary",outputname,".RData"))
                               ,c(paste0(params$val_dir,'/Output/',tolower(params$proj),
                                         '_outputsummary.csv'),
                                  paste0(params$datapath,"/",tolower(params$proj),
                                         "_outputsummary",outputname,"_NMC.RData"))
                               )
          key_column_list <- list(c('exposure','type','demo','freq')
                                 ,c('exposure','type','demo','freq'))
        }
      } else {
        filename_list <- list(c(paste0(params$val_dir,'/Output/',tolower(params$proj),
                                       '_outputsummary_wtd.csv'),
                                paste0(params$datapath,"/",tolower(params$proj),
                                       "_outputsummary",outputname,".RData"))
                             )
        key_column_list <- list(c('exposure','type','demo','freq'))
      }
      
      validate_23(params,filename_list,key_column_list)
      
    }
    
  }
  
}
################################################################################
############################## Run Main Function ###############################
################################################################################
if (getOption('run.main', default=TRUE)) {
  
  # UTILITY FUNCTIONS (these are normally loaded by 10SetParameters)
  
  # Function that checks if package is installed.
  # If installed, it loads it. If it isn't, it installs it.
  pkgTest <- function(x) {
    if (!(x %in% installed.packages()[, 'Package'])) {
      tryCatch({
        message(paste0('INSTALLING PACKAGE ',toupper(x)))
        if (x == 'xda') {
          install_github("ujjwalkarn/xda")
        } else {
          install.packages(x, quiet = TRUE)
        }
      }, error = function(e) {
        stop(paste0('  ERROR: ',e))
      })
    } 
    message(paste0('LOADING PACKAGE ',toupper(x)))
    library(x,character.only = TRUE, quietly = TRUE)
  }
  
  # Function to format list to write to file
  write_list <- function(prefix,list,indent,total_length) {
    llist <- length(list)
    cond <- 1
    count <- 1
    while (cond) {
      ltoprint <- paste(list[1:count],collapse=', ')
      line <- paste(prefix,ltoprint)
      lline <- nchar(line)
      if (lline < total_length) {
        if (count < llist) {
          count <- count+1
        } else {
          cond <- 0
        }
      } else {
        cond <- 0
        count <- count-1
        if (count < 1) {
          line <- prefix
        } else {
          ltoprint <- paste(list[1:count],collapse=', ')
          line <- paste(prefix,ltoprint)
        }
      }
    }
    message(line)
    
    prefix <- paste(rep(" ",indent),collapse="")
    
    while (count < llist) {
      cond <- 1
      count <- count+1
      count2 <- count
      while (cond) {
        ltoprint <- paste(list[count2:count],collapse=', ')
        line <- paste0(prefix,ltoprint)
        lline <- nchar(line)
        if (lline < total_length) {
          if (count < llist) {
            count <- count+1
          } else {
            cond <- 0
          }
        } else {
          cond <- 0
          count <- count-1
          if (count < count2) {
            count <- count+1
          } else {
            ltoprint <- paste(list[count2:count],collapse=', ')
            line <- paste0(prefix,ltoprint)
          }
        }
      }
      message(line)
    }
  }
  
  # Get index of columns in a dataset
  get_indexes <- function(columns,dataset) {
    columns <- tolower(columns)
    indexes <- c()
    for (colname in columns) {
      indexes <- c(indexes,match(colname,tolower(names(dataset))))
    }
    return(indexes)
  }
  
  # This function returns TRUE wherever elements are different, including NA's,
  # and FALSE everywhere else.
  compareNA <- function(v1,v2) {
    same <- (v1 == v2) | (is.na(v1) & is.na(v2))
    same[is.na(same)] <- FALSE
    return(!same)
  }
  
  # Function to compare two data.table objects and write differences to file
  validate_dt_file <- function(Modelfile,Comparisonfile,key_column,outname,
                               dump_diff_file) {
    
    # First test: Check that both files have the same number of columns and rows
    
    ncolSAS <- base::ncol(Modelfile)
    nrowSAS <- base::nrow(Modelfile)
    ncolCSV <- base::ncol(Comparisonfile)
    nrowCSV <- base::nrow(Comparisonfile)
    
    if ((ncolSAS == ncolCSV) && (nrowSAS == nrowCSV)) { 
      
      # Second test: Check that columns in both files have the same names
      #              (case can be different (uppercase vs. lowercase) and order
      #               of the columns can be different, but names have to be the same)
      
      SAScolnames <- base::sort(base::tolower(base::colnames(Modelfile)))
      CSVcolnames <- base::sort(base::tolower(base::colnames(Comparisonfile)))
      ndiff <- 0
      for (icol in 1:base::length(SAScolnames)) {
        if (SAScolnames[icol] != CSVcolnames[icol]) { ndiff <- ndiff+1 }
      }
      
      if (ndiff == 0) {
        
        # Third test: Compare files column-by-column
        
        # Rearrange Rfile columns to be in the same order as Modelfile
        base::names(Modelfile) <- base::tolower(base::names(Modelfile))
        base::names(Comparisonfile) <- base::tolower(base::names(Comparisonfile))
        if (ncolSAS > 1) {
          Comparisonfile <- Comparisonfile[,names(Modelfile),with=F]
        }
        
        # Sort datasets according to key_column to have rows in the same order
        indexes <- get_indexes(key_column,Modelfile)
        key_names <- base::names(Modelfile)[indexes]
        if (nrowSAS > 1) {
          Modelfile <- setorderv(Modelfile,key_names)
          Comparisonfile <- setorderv(Comparisonfile,key_names)
        }
        
        # Use "compare" function to validate each column in the file against its 
        # SAS counterpart
        count <- 0
        for (i in 1:ncolSAS) {
          #i=6
          comparison <- compare::compare(Modelfile[[i]], Comparisonfile[[i]]
                                         ,equal = TRUE
                                         ,coerce = TRUE
                                         #,shorten = TRUE
                                         #,ignoreOrder = TRUE
                                         #,ignoreNameCase = TRUE
                                         #,ignoreNames = TRUE
                                         ,ignoreAttrs = TRUE
                                         ,round = TRUE
                                         #,ignoreCase = TRUE
                                         #,trim = TRUE
                                         #,dropLevels = TRUE
                                         #,ignoreLevelOrder = TRUE
                                         #,ignoreDimOrder = TRUE
                                         #,ignoreColOrder = TRUE
                                         #,ignoreComponentOrder = TRUE
                                         #,colsOnly = TRUE
                                         #,allowAll = TRUE
          )
          
          # If discrepancies are found, write discrepancies to file for evaluation
          # by the user
          if (!comparison$result) {
            count <- count+1
            base::message(paste0('  - Found discrepancies in column: ',
                                 base::names(Modelfile)[i]))
            if (dump_diff_file) {
              SAS_np <- Modelfile[compareNA(comparison$tM[], comparison$tC[]),c(indexes,i),with=F]
              
              CSV_np <- Comparisonfile[compareNA(comparison$tM[], comparison$tC[]),c(indexes,i),with=F]
              
              base::names(SAS_np) <- base::paste0('Model_',base::names(SAS_np))
              base::names(CSV_np) <- base::paste0('Comparison_',base::names(CSV_np))
              for (j in 1:base::length(key_names)) {
                base::names(CSV_np)[base::names(CSV_np) == base::paste0('Comparison_',key_names[j])] <- key_names[j]
                base::names(SAS_np)[base::names(SAS_np) == base::paste0('Model_',key_names[j])] <- key_names[j]
              }
              
              diff <- base::merge(SAS_np, CSV_np, by=key_names, all=TRUE)
              base::message(paste0('    ',nrow(diff),' discrepancies found.'))
              model_name <- paste0('Model_',names(Modelfile)[i])
              comparison_name <- paste0('Comparison_',names(Modelfile)[i])
              if (class(diff[[model_name]]) == 'numeric') {
                diff$`%Diff` <- round((diff[,comparison_name,with=F]-diff[,model_name,with=F])/
                                        diff[,model_name,with=F]*100,0)
              }
              
              if (count == 1) {
                xlsx::write.xlsx(diff,paste0(outname,'.xlsx'),row.names=FALSE
                                 ,sheetName = base::names(Modelfile)[i])
              } else {
                xlsx::write.xlsx(diff,paste0(outname,'.xlsx'),row.names=FALSE
                                 ,sheetName = base::names(Modelfile)[i],append = TRUE)
              }
              
              jgc()
            }
          }
        }
        
        if (count == 0) {
          base::message('  - No discrepancies were found.')
        } else {
          if (dump_diff_file) {
            base::message(paste0('  - Report saved in ',outname,'.xlsx'))
            # Sys.setenv(RSTUDIO_PANDOC="C:/Program Files/RStudio/bin/pandoc")
            # render(paste0(params$code_loc,"/gen_val_report.Rmd"),#'all',
            #        output_file = paste0(outname,'.html'),
            #        params = list(path = params$path, outname = outname),
            #        quiet = T)
          }
        }
        
        
      } else {
        
        base::message('  - Discrepancies were found.')
        base::message('    Column names in model and comparison datasets do not match.')
        write_list('    Column names in model dataset are:', SAScolnames, 
                   6,80)
        write_list('    Column names in comparison dataset are:', CSVcolnames, 
                   6,80)
        
      }
      
    } else {
      
      base::message('  - Discrepancies were found.')
      base::message(base::paste0('    The model dataset has ',base::toString(nrowSAS)
                                 ,' rows and ',base::toString(ncolSAS),' columns.'))
      base::message(base::paste0('    while the comparison dataset has ',base::toString(nrowCSV)
                                 ,' rows and ',base::toString(ncolCSV),' columns.'))
    }
    
  }
  
  # Function to collect Java garbage when using xlsx package
  jgc <- function() {
    base::gc()
    .jcall("java/lang/System", method = "gc")
  }
  
  # Function to load and rename RData file, and allocate memory to it
  loadRData <- function(fileName,colalloc){
    #loads an RData file, and returns it
    load(fileName)
    alloc.col(get(ls()[ls() != "fileName"]),colalloc)
  }
  
  # Function to load and rename RData file
  loadRData_noalloc <- function(fileName) {
    #loads an RData file, and returns it
    load(fileName)
    get(ls()[ls() != "fileName"])
  }
  
  # IMPORT PACKAGES
  # (these are normally loaded by the main script - 10SetParameters)
  pkgTest('haven')
  options(java.parameters = "-Xmx16000m")
  pkgTest('rJava')
  pkgTest('xlsx')
  pkgTest('compare')
  pkgTest('jsonlite')
  pkgTest('data.table')
  pkgTest('rmarkdown')
  pkgTest('knitr')
  pkgTest('kableExtra')
  pkgTest('plyr')
  
  path <- 'E:/eBay'
  params <- fromJSON(file.path(path,'params.json'), simplifyDataFrame=TRUE)
  if (params$use_sas_input) {
    if (params$val_format == 'sas7bdat') {
      message(paste0('  Loading ',params$val_dir,'/SAS_Datasets/',
                     tolower(params$bigseg),'_',tolower(params$datatype),'_wtd.sas7bdat'))
      # argus_recoded_wtd_complete <- as.data.table(haven::read_sas(paste0(params$val_dir,
      #                      '/SAS_Datasets/',tolower(params$bigseg),'_',
      #                     tolower(params$datatype),'_wtd_complete.sas7bdat')))
      argus_recoded_wtd <- as.data.table(haven::read_sas(paste0(params$val_dir,
                                    '/SAS_Datasets/',tolower(params$bigseg),'_',
                                    tolower(params$datatype),'_wtd.sas7bdat')))
    } else if (params$val_format == 'RData') {
      if (params$path == 'E:/McDonalds') {
        message(paste0('  Loading ',params$val_dir,'/SAS_Datasets/',tolower(params$bigseg),
                       '_',tolower(params$datatype),'_wtd_complete.RData'))
        argus_recoded_wtd <- loadRData_noalloc(paste0(params$val_dir,'/SAS_Datasets/',
                                                      tolower(params$bigseg),'_',
                                                      tolower(params$datatype),
                                                      '_wtd_complete.RData'))
      } else {
        message(paste0('  Loading ',params$val_dir,'/SAS_Datasets/',tolower(params$bigseg),
                       '_',tolower(params$datatype),'_wtd.RData'))
        argus_recoded_wtd <- loadRData_noalloc(paste0(params$val_dir,'/SAS_Datasets/',
                                                      tolower(params$bigseg),'_',
                                                      tolower(params$datatype),'_wtd.RData'))
      }
    }
    names(argus_recoded_wtd) <- tolower(names(argus_recoded_wtd))
  } else {
    message(paste0('  Loading ',params$datapath,'/argus_20b.RData'))
    argus_recoded_wtd <- loadRData(paste0(params$datapath,'/argus_20b.RData'),
                                   params$colalloc)
  }
  main_23(params,argus_recoded_wtd)
  
}